#include <clocale>
#include <iostream>
#include <stdexcept>

using namespace std;

int main( int argc, char* argv[] ) {
   cout << "russian string: Выводится русский текст" << endl;
   cout << "default locale: " << locale( "" ).name().c_str() << endl;
   cout << "old cout.locale: " << cout.getloc().name().c_str() << endl;
   while( true ) {
      char s[ 40 ];
      cout << "new locale: " << flush;
      cin >> s;
      locale loc;
      try { loc = locale( (char*)s ); }
      catch( std::runtime_error ) {
         cout << "wrong locale" << endl;
         continue;
      }
      cout.imbue( loc ); 
      cout << "cout.locale : " << cout.getloc().name().c_str() << endl;
      locale::global( loc );
      cout << "locale : " << std::setlocale( LC_ALL, NULL ) << endl;
      cout << "russian string: Выводится русский текст" << endl;
   }
   return 0;
}
